//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * ジョイスティックステートヘッダ
 * @author Junpee
 */

#ifndef JOYSTICK_STATE_H_
#define JOYSTICK_STATE_H_

namespace Lamp{

class BinaryWriter;
class BinaryReader;

//------------------------------------------------------------------------------
/**
 * ジョイスティックステート
 */
class JoystickState{
public:
	/// 最大視点コントローラ数
	static const int maxPOVCount = 4;

	/// 最大スライダ数
	static const int maxSliderCount = 2;

	/// 最大ボタン数
	static const int maxButtonCount = 32;

	/// 軸データ最大値
	static const int maxAxisValue = 10000;

	/// 軸データ最小値
	static const int minAxisValue = -10000;

	/// 視点コントローラ最大値
	static const int maxPOVValue = 36000;

	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	JoystickState(){ clear(); }

	/**
	 * デストラクタ
	 */
	virtual ~JoystickState(){}

	/**
	 * クリア
	 */
	virtual void clear(){
		xAxis_ = yAxis_ = zAxis_ = 0;
		xRotation_ = yRotation_ = zRotation_ = 0;
		for(int i = 0; i < maxPOVCount; i++){ povs_[i] = -1; }
		for(int i = 0; i < maxSliderCount; i++){ sliders_[i] = 0; }
		for(int i = 0; i < maxButtonCount; i++){ buttons_[i] = false; }
	}

	//--------------------------------------------------------------------------
	/**
	 * X軸の設定
	 * @param xAxis X軸
	 */
	virtual void setXAxis(int xAxis){ xAxis_ = xAxis; }

	/**
	 * X軸の取得
	 * @return X軸
	 */
	virtual int getXAxis() const{ return xAxis_; }

	/**
	 * Y軸の設定
	 * @param yAxis Y軸
	 */
	virtual void setYAxis(int yAxis){ yAxis_ = yAxis; }

	/**
	 * Y軸の取得
	 * @return Y軸
	 */
	virtual int getYAxis() const{ return yAxis_; }

	/**
	 * Z軸の設定
	 * @param zAxis Z軸
	 */
	virtual void setZAxis(int zAxis){ zAxis_ = zAxis; }

	/**
	 * Z軸の取得
	 * @return Z軸
	 */
	virtual int getZAxis() const{ return zAxis_; }

	//--------------------------------------------------------------------------
	/**
	 * X回転の設定
	 * @param xRotation X回転
	 */
	virtual void setXRotation(int xRotation){ xRotation_ = xRotation; }

	/**
	 * X回転の取得
	 * @return X回転
	 */
	virtual int getXRotation() const{ return xRotation_; }

	/**
	 * Y回転の設定
	 * @param yRotation Y回転
	 */
	virtual void setYRotation(int yRotation){ yRotation_ = yRotation; }

	/**
	 * Y回転の取得
	 * @return Y回転
	 */
	virtual int getYRotation() const{ return yRotation_; }

	/**
	 * Z回転の設定
	 * @param zRotation Z回転
	 */
	virtual void setZRotation(int zRotation){ zRotation_ = zRotation; }

	/**
	 * Z回転の取得
	 * @return Z回転
	 */
	virtual int getZRotation() const{ return zRotation_; }

	//--------------------------------------------------------------------------
	/**
	 * 視点コントローラ値の設定
	 * @param id 視点コントローラID
	 * @param pov 視点コントローラ値
	 */
	virtual void setPOV(int id, int pov){
		Assert((id >= 0) && (id < maxPOVCount));
		povs_[id] = pov;
	}

	/**
	 * 視点コントローラ値の取得
	 * @param id 視点コントローラID
	 * @return 視点コントローラ値
	 */
	virtual int getPOV(int id) const{
		Assert((id >= 0) && (id < maxPOVCount));
		return povs_[id];
	}

	//--------------------------------------------------------------------------
	/**
	 * スライダ値の設定
	 * @param id スライダID
	 * @param slider スライダ値
	 */
	virtual void setSlider(int id, int slider){
		Assert((id >= 0) && (id < maxSliderCount));
		sliders_[id] = slider;
	}

	/**
	 * スライダ値の取得
	 * @param id スライダID
	 * @return スライダ値
	 */
	virtual int getSlider(int id) const{
		Assert((id >= 0) && (id < maxSliderCount));
		return sliders_[id];
	}

	//--------------------------------------------------------------------------
	/**
	 * ボタンの設定
	 * @param id 対象ボタンID
	 * @param pressed trueなら押されている
	 */
	virtual void setButtonPressed(int id, bool pressed){
		Assert((id >= 0) && (id < maxButtonCount));
		buttons_[id] = pressed;
	}

	/**
	 * ボタンが押されているか
	 * @param id 対象ボタンID
	 * @return ボタンが押されていればtrue
	 */
	virtual bool buttonPressed(int id) const{
		Assert((id >= 0) && (id < maxButtonCount));
		return buttons_[id];
	}

	//--------------------------------------------------------------------------
	/**
	 * 文字列への変換
	 * @return 文字列
	 */
	virtual String toString() const{
		String result;
		result.format("( XAxis = %4d , YAxis = %4d , ZAxis = %4d )\n"
			"( XRot = %4d , YRot = %4d , ZRot = %4d )\n"
			"POV %d %d %d %d\n"
			"Slider %d %d\n"
			"Buttons %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d "
			"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
			getXAxis(), getYAxis(), getZAxis(),
			getXRotation(), getYRotation(), getZRotation(),
			getPOV(0),getPOV(1),getPOV(2),getPOV(3),
			getSlider(0), getSlider(1),
			buttonPressed(0), buttonPressed(1), buttonPressed(2),
			buttonPressed(3), buttonPressed(4), buttonPressed(5), 
			buttonPressed(6), buttonPressed(7),
			buttonPressed(8), buttonPressed(9), buttonPressed(10),
			buttonPressed(11), buttonPressed(12), buttonPressed(13), 
			buttonPressed(14), buttonPressed(15),
			buttonPressed(16), buttonPressed(17), buttonPressed(18),
			buttonPressed(19), buttonPressed(20), buttonPressed(21), 
			buttonPressed(22), buttonPressed(23),
			buttonPressed(24), buttonPressed(25), buttonPressed(26),
			buttonPressed(27), buttonPressed(28), buttonPressed(29), 
			buttonPressed(30), buttonPressed(31));
		return result;
	}

	//--------------------------------------------------------------------------
	/**
	 * バイナリ書き出し
	 * @param binaryWriter バイナリライタ
	 */
	virtual void writeBinary(BinaryWriter* binaryWriter) const;

	/**
	 * バイナリ読み込み
	 * @param binaryReader バイナリリーダ
	 */
	virtual void readBinary(BinaryReader* binaryReader);

	//--------------------------------------------------------------------------
private:
	// X軸
	int xAxis_;
	// Y軸
	int yAxis_;
	// Z軸
	int zAxis_;
	// X回転
	int xRotation_;
	// Y回転
	int yRotation_;
	// Z回転
	int zRotation_;
	// 視点コントローラ
	int povs_[maxPOVCount];
	// スライダ
	int sliders_[maxSliderCount];
	// ボタンデータ
	bool buttons_[maxButtonCount];

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of JOYSTICK_STATE_H_
//------------------------------------------------------------------------------
